diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index 8813b5145..f706e07a4 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -183,6 +183,63 @@ public class MathHelper {
         return ((a + b) * (a + b + 1)) / 2 + b;
     }
 
+    // From https://stackoverflow.com/questions/6162651/half-precision-floating-point-in-java
+    // ignores the higher 16 bits
+    public static float fromHalfFloat(short halfFloat )
+    {
+        int mant = halfFloat & 0x03ff;            // 10 bits mantissa
+        int exp =  halfFloat & 0x7c00;            // 5 bits exponent
+        if( exp == 0x7c00 )                   // NaN/Inf
+            exp = 0x3fc00;                    // -> NaN/Inf
+        else if( exp != 0 )                   // normalized value
+        {
+            exp += 0x1c000;                   // exp - 15 + 127
+            if( mant == 0 && exp > 0x1c400 )  // smooth transition
+                return Float.intBitsToFloat( ( halfFloat & 0x8000 ) << 16
+                    | exp << 13 | 0x3ff );
+        }
+        else if( mant != 0 )                  // && exp==0 -> subnormal
+        {
+            exp = 0x1c400;                    // make it normal
+            do {
+                mant <<= 1;                   // mantissa * 2
+                exp -= 0x400;                 // decrease exp by 1
+            } while( ( mant & 0x400 ) == 0 ); // while not normal
+            mant &= 0x3ff;                    // discard subnormal bit
+        }                                     // else +/-0 -> +/-0
+        return Float.intBitsToFloat(          // combine all parts
+            ( halfFloat & 0x8000 ) << 16          // sign  << ( 31 - 15 )
+                | ( exp | mant ) << 13 );         // value << ( 23 - 10 )
+    }
+
+    // returns all higher 16 bits as 0 for all results
+    public static short toHalfFloat(float fval )
+    {
+        int fbits = Float.floatToIntBits( fval );
+        int sign = fbits >>> 16 & 0x8000;          // sign only
+        int val = ( fbits & 0x7fffffff ) + 0x1000; // rounded value
+
+        if( val >= 0x47800000 )               // might be or become NaN/Inf
+        {                                     // avoid Inf due to rounding
+            if( ( fbits & 0x7fffffff ) >= 0x47800000 )
+            {                                 // is or must become NaN/Inf
+                if( val < 0x7f800000 )        // was value but too large
+                    return (short) (sign | 0x7c00);     // make it +/-Inf
+                return (short) (sign | 0x7c00 |        // remains +/-Inf or NaN
+                                    ( fbits & 0x007fffff ) >>> 13); // keep NaN (and Inf) bits
+            }
+            return (short) (sign | 0x7bff);             // unrounded not quite Inf
+        }
+        if( val >= 0x38800000 )               // remains normalized value
+            return (short) (sign | val - 0x38000000 >>> 13); // exp - 127 + 15
+        if( val < 0x33000000 )                // too small for subnormal
+            return (short) sign;                      // becomes +/-0
+        val = ( fbits & 0x7fffffff ) >>> 23;  // tmp exp for subnormal calc
+        return (short) (sign | ( ( fbits & 0x7fffff | 0x800000 ) // add subnormal bit
+                    + ( 0x800000 >>> val - 102 )     // round depending on cut off
+                    >>> 126 - val ));   // div by 2^(1-(exp-127+15)) and >> 13 | exp=0
+    }
+
     private static final float[] SIN_TABLE;
 
     public static final float PI = (float) Math.PI;
diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index 7a3bc79af..877bf8593 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -143,17 +143,12 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission) {
+    public byte getLightIndex(final @NotNull TilePosc tilePos, final int lightEmission) {
         if (this.lightRefEntity != null) {
-            return this.lightRefEntity.getLightmap(this.partialTick);
+            return this.lightRefEntity.getLightIndex(this.partialTick);
         }
 
-        return this.world.getLightmapCoord(tilePos, lightEmission);
-    }
-
-    @Override
-    public int getLightmapCoord(final int skyLight, final int blockLight) {
-        return this.world.getLightmapCoord(skyLight, blockLight);
+        return this.world.getLightIndex(tilePos, lightEmission);
     }
 
     @Override
@@ -218,6 +213,11 @@ public class BlocksContainer implements MutableWorldSource {
         return this.world.getSavedLightValue(lightLayer, tilePos);
     }
 
+    @Override
+    public byte getSavedLightIndex(@NotNull TilePosc tilePos) {
+        return this.world.getSavedLightIndex(tilePos);
+    }
+
     @Override
     public boolean isRetro() {
         return this.world.isRetro();
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 2bc8f61dd..827166fbb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -29,6 +29,7 @@ import net.minecraft.core.sound.BlockSound;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.HitResult;
@@ -90,7 +91,7 @@ public class World implements MutableWorldSource {
     public static boolean AUTOSAVE = true;
 
     public static final int HEIGHT_BLOCKS = 256;
-    public static final int MAX_BRIGHTNESS = 15;
+    public static final int MAX_LIGHT_LEVEL = 15;
 
     public static final int MAX_BLOCK_X = 32000000;
     public static final int MAX_BLOCK_Z = 32000000;
@@ -827,7 +828,7 @@ public class World implements MutableWorldSource {
         if (tilePos.y() < 0) {
             return 0;
         } else {
-            return this.getChunk(tilePos).getRawBrightness(new ChunkTilePos(new TilePos(tilePos.x(), Math.min(tilePos.y(), this.getHeightBlocks() - 1), tilePos.z())), 0);
+            return this.getChunk(tilePos).getRawSkyLightLevel(new ChunkTilePos(new TilePos(tilePos.x(), Math.min(tilePos.y(), this.getHeightBlocks() - 1), tilePos.z())), 0);
         }
     }
 
@@ -847,7 +848,7 @@ public class World implements MutableWorldSource {
 
     private int getBlockLightValue_do(final @NotNull TilePosc tilePos, final boolean first) {
         if (!tilePos.inBounds(this)) {
-            return MAX_BRIGHTNESS;
+            return MAX_LIGHT_LEVEL;
         }
 
         if (first) {
@@ -865,7 +866,7 @@ public class World implements MutableWorldSource {
         if (tilePos.y() < 0) {
             return 0;
         }
-        return this.getChunk(tilePos).getRawBrightness(new ChunkTilePos(tilePos.x(), Math.min(tilePos.y(), this.getHeightBlocks() - 1), tilePos.z()), this.skyDarken);
+        return this.getChunk(tilePos).getRawSkyLightLevel(new ChunkTilePos(tilePos.x(), Math.min(tilePos.y(), this.getHeightBlocks() - 1), tilePos.z()), this.skyDarken);
     }
 
     public boolean canLoadedBlockSeeSky(final @NotNull TilePosc tilePos) {
@@ -905,7 +906,18 @@ public class World implements MutableWorldSource {
         } else if (!this.isBlockLoaded(tilePos)) {
             return 0;
         } else {
-            return this.getChunk(tilePos).getBrightness(lightLayer, new ChunkTilePos(tilePos));
+            return this.getChunk(tilePos).getLightLevel(lightLayer, new ChunkTilePos(tilePos));
+        }
+    }
+
+    @Override
+    public byte getSavedLightIndex(@NotNull TilePosc tilePos) {
+        if (!tilePos.inBounds(this)) {
+            return LightLayer.DEFAULT_LIGHT_INDEX;
+        } else if (!this.isBlockLoaded(tilePos)) {
+            return 0;
+        } else {
+            return this.getChunk(tilePos).getLightIndex(new ChunkTilePos(tilePos));
         }
     }
 
@@ -917,7 +929,7 @@ public class World implements MutableWorldSource {
     @Override
     public void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos, final int value) {
         if (tilePos.inBounds(this) && this.isBlockLoaded(tilePos)) {
-            this.getChunk(tilePos).setBrightness(lightLayer, new ChunkTilePos(tilePos), value);
+            this.getChunk(tilePos).setLightLevel(lightLayer, new ChunkTilePos(tilePos), value);
             for (final @NotNull LevelListener listener : this.listeners) {
                 listener.blockChanged(tilePos.x(), tilePos.y(), tilePos.z());
             }
@@ -931,33 +943,21 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission) {
-        int skyLight = this.getSavedLightValue(LightLayer.Sky, tilePos);
-        int blockLight = Math.max(this.getSavedLightValue(LightLayer.Block, tilePos), lightEmission);
+    public byte getLightIndex(final @NotNull TilePosc tilePos, final int lightEmission) {
+        byte lightIndex = getSavedLightIndex(tilePos);
+        lightIndex = LightIndexHelper.max(lightIndex, (byte) lightEmission);
 
         if (this.getBlockLitInteriorSurface(tilePos)) {
             TilePos queryPos = new TilePos();
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.UP, queryPos)));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.DOWN, queryPos)));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.EAST, queryPos)));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.WEST, queryPos)));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.SOUTH, queryPos)));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.NORTH, queryPos)));
-
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.UP, queryPos)));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.DOWN, queryPos)));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.EAST, queryPos)));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.WEST, queryPos)));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.SOUTH, queryPos)));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.NORTH, queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.up(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.down(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.east(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.west(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.south(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.north(queryPos)));
         }
 
-        return this.getLightmapCoord(skyLight, blockLight);
-    }
-
-    @Override
-    public int getLightmapCoord(final int skyLight, final int blockLight) {
-        return 0; // TODO figure out if/how we would get this working in core
+        return lightIndex;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index 21aadb3ef..bfea39716 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -56,15 +56,13 @@ public interface WorldSource {
         return this.getBrightness(new TilePos(x, y, z), lightEmission);
     }
 
-    int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission);
+    byte getLightIndex(final @NotNull TilePosc tilePos, final int lightEmission);
 
     @Deprecated
-    default int getLightmapCoord(final int x, final int y, final int z, final int lightEmission) {
-        return this.getLightmapCoord(new TilePos(x, y, z), lightEmission);
+    default byte getLightmapCoord(final int x, final int y, final int z, final int lightEmission) {
+        return this.getLightIndex(new TilePos(x, y, z), lightEmission);
     }
 
-    int getLightmapCoord(int skyLight, int blockLight);
-
     float getLightBrightness(final @NotNull TilePosc tilePos);
 
     @Deprecated
@@ -132,6 +130,8 @@ public interface WorldSource {
 
     int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos);
 
+    byte getSavedLightIndex(@NotNull TilePosc tilePos);
+
     @Deprecated
     default int getSavedLightValue(final @NotNull LightLayer layer, final int x, final int y, final int z) {
         return this.getSavedLightValue(layer, new TilePos(x, y, z));
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 15a3f0922..24d906cfd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -8,9 +8,9 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
-import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.ChunkPosc;
@@ -23,7 +23,12 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
 import org.slf4j.Logger;
 
-import java.util.*;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+import java.util.Random;
 
 public class Chunk {
     private static final Logger LOGGER = LogUtils.getLogger();
@@ -209,7 +214,7 @@ public class Chunk {
         final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
         if (iPos.y < heightValue) {
             for (int dy = iPos.y; dy < heightValue; dy++) {
-                this.setBrightness(LightLayer.Sky, iPos.x, dy, iPos.z, World.MAX_BRIGHTNESS);
+                this.setBrightness(LightLayer.Sky, iPos.x, dy, iPos.z, World.MAX_LIGHT_LEVEL);
             }
         } else {
             this.world.scheduleLightingUpdate(LightLayer.Sky, new TilePos(worldPos.x, heightValue, worldPos.z), new TilePos(worldPos.x, iPos.y, worldPos.z));
@@ -218,7 +223,7 @@ public class Chunk {
             }
         }
 
-        int lightValue = World.MAX_BRIGHTNESS;
+        int lightValue = World.MAX_LIGHT_LEVEL;
         final int lightY = iPos.y;
         while (iPos.y > 0 && lightValue > 0) {
             iPos.y--;
@@ -230,7 +235,7 @@ public class Chunk {
             if (lightValue < 0) {
                 lightValue = 0;
             }
-            this.setBrightness(LightLayer.Sky, iPos, lightValue);
+            this.setLightLevel(LightLayer.Sky, iPos, lightValue);
         }
 
         for (; iPos.y > 0 && Blocks.lightBlock[this.getBlockId(iPos.down(queryPos))] == 0; iPos.y--) {
@@ -489,39 +494,47 @@ public class Chunk {
         return true;
     }
 
-    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
+    public int getLightLevel(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
+        if (!tilePos.inBounds()) {
+            return 0;
+        }
+
+        return this.getSection(tilePos).getLightLevel(lightLayer, new ChunkSectionTilePos(tilePos));
+    }
+
+    public byte getLightIndex(final @NotNull ChunkTilePosc tilePos) {
         if (!tilePos.inBounds()) {
             return 0;
         }
 
-        return this.getSection(tilePos).getBrightness(lightLayer, new ChunkSectionTilePos(tilePos));
+        return this.getSection(tilePos).getLightIndex(new ChunkSectionTilePos(tilePos));
     }
 
     @Deprecated
     public final int getBrightness(final @NotNull LightLayer lightLayer, final int x, final int y, final int z) {
-        return this.getBrightness(lightLayer, new ChunkTilePos(x, y, z));
+        return this.getLightLevel(lightLayer, new ChunkTilePos(x, y, z));
     }
 
-    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos, final int value) {
+    public void setLightLevel(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos, final int value) {
         if (!tilePos.inBounds()) {
             return;
         }
 
-        this.getSection(tilePos).setBrightness(lightLayer, new ChunkSectionTilePos(tilePos), value);
+        this.getSection(tilePos).setLightLevel(lightLayer, new ChunkSectionTilePos(tilePos), value);
         this.isModified = true;
     }
 
     @Deprecated
     public final void setBrightness(final @NotNull LightLayer lightLayer, final int x, final int y, final int z, final int value) {
-        this.setBrightness(lightLayer, new ChunkTilePos(x, y, z), value);
+        this.setLightLevel(lightLayer, new ChunkTilePos(x, y, z), value);
     }
 
-    public int getRawBrightness(final @NotNull ChunkTilePosc tilePos, final int subtractedSkyLight) {
+    public int getRawSkyLightLevel(final @NotNull ChunkTilePosc tilePos, final int subtractedSkyLight) {
         if (!tilePos.inBounds()) {
             return 0;
         }
 
-        final int lightValue = this.getSection(tilePos).getRawBrightness(new ChunkSectionTilePos(tilePos), subtractedSkyLight);
+        final int lightValue = this.getSection(tilePos).getRawSkyLightLevel(new ChunkSectionTilePos(tilePos), subtractedSkyLight);
         if (lightValue > 0) {
             Chunk.isLit = true;
         }
@@ -531,7 +544,7 @@ public class Chunk {
 
     @Deprecated
     public final int getRawBrightness(final int x, final int y, final int z, final int subtractedSkyLight) {
-        return this.getRawBrightness(new ChunkTilePos(x, y, z), subtractedSkyLight);
+        return this.getRawSkyLightLevel(new ChunkTilePos(x, y, z), subtractedSkyLight);
     }
 
     public void addEntity(final @NotNull Entity entity) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 77e360966..8513989ec 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biome;
@@ -116,32 +117,20 @@ public class ChunkCache
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission) {
-        int skyLight = getSavedLightValue(LightLayer.Sky, tilePos);
-        int blockLight = Math.max(getSavedLightValue(LightLayer.Block, tilePos), lightEmission);
+    public byte getLightIndex(final @NotNull TilePosc tilePos, final int lightEmission) {
+        byte lightIndex = getSavedLightIndex(tilePos);
+        lightIndex = LightIndexHelper.max(lightIndex, (byte) lightEmission);
 
         if (this.getBlockLitInteriorSurface(tilePos)) {
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, tilePos.up(this.queryTilePos)));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, tilePos.down(this.queryTilePos)));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, tilePos.east(this.queryTilePos)));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, tilePos.west(this.queryTilePos)));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, tilePos.south(this.queryTilePos)));
-            skyLight = Math.max(skyLight, getSavedLightValue(LightLayer.Sky, tilePos.north(this.queryTilePos)));
-
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, tilePos.up(this.queryTilePos)));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, tilePos.down(this.queryTilePos)));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, tilePos.east(this.queryTilePos)));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, tilePos.west(this.queryTilePos)));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, tilePos.south(this.queryTilePos)));
-            blockLight = Math.max(blockLight, getSavedLightValue(LightLayer.Block, tilePos.north(this.queryTilePos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.up(this.queryTilePos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.down(this.queryTilePos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.east(this.queryTilePos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.west(this.queryTilePos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.south(this.queryTilePos)));
+            lightIndex = LightIndexHelper.max(lightIndex, getSavedLightIndex(tilePos.north(this.queryTilePos)));
         }
 
-        return this.getLightmapCoord(skyLight, blockLight);
-    }
-
-    @Override
-    public int getLightmapCoord(final int skyLight, final int blockLight) {
-        return this.world.getLightmapCoord(skyLight, blockLight);
+        return lightIndex;
     }
 
     @Override
@@ -181,7 +170,7 @@ public class ChunkCache
             }
             return brightness;
         } else {
-            return getChunk(tilePos).getRawBrightness(this.queryChunkTilePos.set(tilePos), this.world.skyDarken);
+            return getChunk(tilePos).getRawSkyLightLevel(this.queryChunkTilePos.set(tilePos), this.world.skyDarken);
         }
     }
 
@@ -242,7 +231,18 @@ public class ChunkCache
         } else if (!this.isChunkLoaded(tilePos)) {
             return 0;
         } else {
-            return this.getChunk(tilePos).getBrightness(lightLayer, this.queryChunkTilePos.set(tilePos));
+            return this.getChunk(tilePos).getLightLevel(lightLayer, this.queryChunkTilePos.set(tilePos));
+        }
+    }
+
+    @Override
+    public byte getSavedLightIndex(@NotNull TilePosc tilePos) {
+        if (tilePos.y() < 0 || tilePos.y() >= this.getHeightBlocks()) {
+            return LightLayer.DEFAULT_LIGHT_INDEX;
+        } else if (!this.isChunkLoaded(tilePos)) {
+            return 0;
+        } else {
+            return this.getChunk(tilePos).getLightIndex(this.queryChunkTilePos.set(tilePos));
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index f716543c3..11196739e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -1,28 +1,37 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
+import com.mojang.nbt.NbtIo;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.Tag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
-import com.mojang.nbt.tags.Tag;
-import com.mojang.nbt.tags.CompoundTag;
-import com.mojang.nbt.tags.ListTag;
-import com.mojang.nbt.NbtIo;
-import net.minecraft.core.world.chunk.reader.*;
+import net.minecraft.core.util.helper.LightIndexHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.reader.ChunkReader;
+import net.minecraft.core.world.chunk.reader.ChunkReaderLegacy;
+import net.minecraft.core.world.chunk.reader.ChunkReaderVersion1;
+import net.minecraft.core.world.chunk.reader.ChunkReaderVersion2;
+import net.minecraft.core.world.chunk.reader.ChunkReaderVersion3;
 import net.minecraft.core.world.chunk.writer.ChunkWriter;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
-import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.LevelData;
 import org.slf4j.Logger;
 
-import java.io.*;
+import java.io.File;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.OutputStream;
 import java.nio.file.Files;
-import java.util.*;
+import java.util.Arrays;
+import java.util.List;
 
 public class ChunkLoaderLegacy
     implements IChunkLoader
@@ -227,11 +236,23 @@ public class ChunkLoaderLegacy
         if (section.data != null) {
             writer.putData(section.yPosition, section.data);
         }
-        if (section.skylightMap != null) {
-            writer.putSkyLight(section.yPosition, section.skylightMap);
-        }
-        if (section.blocklightMap != null) {
-            writer.putBlockLight(section.yPosition, section.blocklightMap);
+        if (section.lightData != null) {
+            byte[] blockLightData = new byte[section.lightData.length / 2];
+            byte[] skyLightData = new byte[section.lightData.length / 2];
+            for (int i = 0; i < section.lightData.length / 2; i++) {
+                byte lightIndex0 = section.lightData[i * 2];
+                byte lightIndex1 = section.lightData[i * 2 + 1];
+
+                int block0 = LightIndexHelper.blockLightFromIndex(lightIndex0);
+                int block1 = LightIndexHelper.blockLightFromIndex(lightIndex1);
+
+                int sky0 = LightIndexHelper.skyLightFromIndex(lightIndex0);
+                int sky1 = LightIndexHelper.skyLightFromIndex(lightIndex1);
+                blockLightData[i] = (byte) (block1 << 4 | block0);
+                skyLightData[i] = (byte) (sky1 << 4 | sky0);
+            }
+            writer.putSkyLight(section.yPosition, skyLightData);
+            writer.putBlockLight(section.yPosition, blockLightData);
         }
         writer.putBiomeMap(section.yPosition, section.biome);
     }
@@ -323,20 +344,27 @@ public class ChunkLoaderLegacy
     public static void loadChunkSectionFromCompound(ChunkSection section, ChunkReader reader, Int2ObjectMap<String> biomeRegistry) {
         section.blocks = reader.getBlocks(section.yPosition);
         section.data = reader.getData(section.yPosition);
-        section.skylightMap = reader.getSkyLight(section.yPosition);
-        section.blocklightMap = reader.getBlockLight(section.yPosition);
+        ChunkNibbleArray skylightMap = reader.getSkyLight(section.yPosition);
+        ChunkNibbleArray blocklightMap = reader.getBlockLight(section.yPosition);
+        section.lightData = new byte[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
+        if (skylightMap != null && skylightMap.data != null) {
+            for (int i = 0; i < section.lightData.length/2; i++) {
+                section.lightData[i * 2] |= (byte) ((skylightMap.data[i] & 0xF) << 4);
+                section.lightData[i * 2 + 1] |= (byte) ((((skylightMap.data[i] & 0xF0) >> 4) & 0xF) << 4);
+            }
+        }
+        if (blocklightMap != null && blocklightMap.data != null) {
+            for (int i = 0; i < section.lightData.length/2; i++) {
+                section.lightData[i * 2] |= (byte) (blocklightMap.data[i] & 0xF);
+                section.lightData[i * 2 + 1] |= (byte) (((blocklightMap.data[i] & 0xF0) >> 4) & 0xF);
+            }
+        }
         section.biome = reader.getBiomeMap(section.yPosition, biomeRegistry);
 
         // Recreate any missing data
         if (section.data != null && !section.data.isValid()) {
             section.data = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
         }
-        if (section.skylightMap != null && !section.skylightMap.isValid()) {
-            section.skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-        }
-        if (section.blocklightMap != null && !section.blocklightMap.isValid()) {
-            section.blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-        }
         if (section.biome == null || section.biome.length != Chunk.CHUNK_SIZE_X * (ChunkSection.SECTION_SIZE_Y >> 3) * Chunk.CHUNK_SIZE_Z) {
             section.biome = new byte[Chunk.CHUNK_SIZE_X * (ChunkSection.SECTION_SIZE_Y >> 3) * Chunk.CHUNK_SIZE_Z];
             Arrays.fill(section.biome, (byte)-1);
